this.name = "N-Shields/Ship Configuration Compatibility";

"use strict";

this.startUp = function()
{
	if (!worldScripts.ShipConfiguration_NPCShips)
	{
		delete this.startUp;
		delete this.$interimShipconfigReplacement;
		return;
	}
	var shipconf_version = worldScripts.ShipConfiguration_NPCShips.version.split(".");
	log (this.name,"shipconf version: " + shipconf_version)
	var versionCheck = (parseInt(shipconf_version[0]) > 0 || parseInt(shipconf_version[1]) >= 2);
	log (this.name, "version check: "+versionCheck)
	if ( !(versionCheck || worldScripts.ShipConfiguration_NPCShips._disable_NShields_compatibility) )
	{
		log (this.name, "will adjust shipconfig-NPC.js to fit N-Shields")
		let NPCconf = worldScripts.ShipConfiguration_NPCShips;
		//worldScripts.NShields._damageHandlers.push(NPCconf.$npc_shipTakingDamage)
		NPCconf.shipSpawned = this.$interimShipconfigReplacement
	}
	else log(this.name, "will not adjust Ship Configurationas version is 0.2.0 or higher");
}

this.$interimShipconfigReplacement = function(ship) {
	if (ship.isInSpace == true && 
		ship.isStation == false &&
		ship.isThargoid == false &&
		ship.isPiloted == true &&
		ship.isCargo == false &&
		ship.isRock == false &&
		ship.isWeapon == false &&
		ship.isMissile == false &&
		ship.isMine == false &&
		ship.isSubEntity == false &&
		ship.isBeacon == false &&
		ship.isVisualEffect == false && 
		ship.scanClass != "CLASS_NO_DRAW" && ship.scanClass != "CLASS_ROCK" && 
		((this._useExclusions == false && this._includeRoles.indexOf(ship.primaryRole) >= 0) ||
		(this._useExclusions == true && this._excludeRoles.indexOf(ship.primaryRole) == -1))) {
		if (!ship.scriptInfo.no_sc_config || this._trueValues.indexOf(ship.scriptInfo.no_sc_config) == -1) {
			var conf = worldScripts.ShipConfiguration_Core;
			if (conf._disabled == false && conf._applyToNPC == true) {
				// add base equipment
				conf.$installBaseEquipment(ship);
				// adjust performance
				conf.$updateShipSpecs(ship);
				
				//N-Shields: apply shield changes from shipconfig equipment, if the other shipSpawned handler ran first & missed these
				if (ship.script.NShields_labels) worldScripts.NShields.$applyShieldUpgrades(ship, ship.script.NShields_labels);

				ship.script._debugShipConfig = false;
				
				// make sure existing scripts are kept in monkey patch locations
				//if (ship.script.$sc_hold_shipTakingDamage == null) ship.script.$sc_hold_shipTakingDamage = ship.script.shipTakingDamage; //commented out because N-Shields does this for itself
				if (ship.script.$sc_hold_shipRemoved == null) ship.script.$sc_hold_shipRemoved = ship.script.shipRemoved;
				// attach our new scripts
				if (!ship.script.NShields_damageHandlers) ship.script.NShields_damageHandlers = []; //N-Shields alteration: set up handler array if it doesn't yet 
				ship.script.NShields_damageHandlers.push(this.$npc_shipTakingDamage)		    //and push the shipconfig handler onto it
				//ship.script.shipTakingDamage = this.$npc_shipTakingDamage; //commented out because N-Shields will call it from the damage handler array (see previous 2 lines)
				ship.script.shipRemoved = this.$npc_shipRemoved;

				ship.script.$stopTimer = this.$stopTimer;
				ship.script.$checkTemp = this.$checkTemp;
				ship.script.$initialise = this.$initialiseTimer;
				
				ship.script._armourType = conf.$equipmentItemInUse("armour", ship);
				if (ship.script._armourType != "") {
					var info = EquipmentInfo.infoForKey(ship.script._armourType);
					ship.script._armourFront = 100;
					ship.script._armourAft = 100;
					ship.script._damagePoint = info.scriptInfo.damage_point;
					ship.script._armourStrength = info.scriptInfo.armour_strength;
					info = null;
				}

				ship.script.$initialise();
			}
			conf = null;
		}
	}
}
